#ifndef __MT_H__
#define __MT_H__
// If you want to debug the macro code replace the macro code
// manually in the class defination.
// MFT_DEF must be declared within the class defination.
// MFT_INIT and MFT_INIT_END pair must be outside the class
// defination.
// Message Function Table MACROS MFT_DEF (,)and MFT_INIT(,,)

#define MFT_DEF(className, _CALLBACK_) typedef\
   MRESULT (className::*MSGFNPTR)(HWND hwnd,ULONG msg, MPARAM mp1,MPARAM mp2);\
   typedef struct {\
	    int    msg;\
	    MSGFNPTR  function;\
   }MFT;\
   static MFT msgFunction[];\
   MRESULT _CALLBACK_  (HWND hwnd,ULONG msg,MPARAM mp1,MPARAM mp2);

// IMPORTANT: For window procedure only this WndProc is used
// for dialog procedures same stuff has to be declared, but call
// to WinDefDlgProc() is to be made instead of WinDefWindowProc()

#define MFT_INIT(className, _CALLBACK_, _DEFAULT_CALLBACK_) \
MRESULT className:: _CALLBACK_ (HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2){\
   int      i;\
   int 	   done   = FALSE;\
   MRESULT retVal = (MRESULT)FALSE;\
   for(i=0; msgFunction[i].msg && !done; i++) {\
	    if(msg == msgFunction[i].msg){\
		    retVal = (this->*(msgFunction[i].function))(hwnd, msg, mp1, mp2);\
		    done = TRUE;\
	    }\
   }\
   if(!done)\
	    retVal = _DEFAULT_CALLBACK_ (hwnd, msg, mp1, mp2);\
   return(retVal);\
}\
className::MFT  className::msgFunction[]={

#define MFT_INIT_END \
			{ 0L,          NULL}\
			};

// standard parameters. H(handle) M(message) 1(mp1) 2(mp2)
#define HM12       HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2
#define USE_HM12   hwnd; msg; mp1; mp2;

#endif
